searchNodes=[{"doc":"Elixir introduces into the world of CS, the &quot;multiverse testing&quot; pattern. This is a pattern where tests are run concurrently and each test sees a shard of global state. Examples: Mox: each tests has access to the global module mock, sharded by the pid of the running test. Ecto: each test has access to a &quot;database sandbox&quot;, which is a checked out transaction on the global database that acts as its own database shard. Hound,Wallaby: each test generates an ID that is passed outside of the BEAM that is reintercepted on ingress to the BEAM; this ID is then used to reconnect to the parent test pid. This library implements Multiverses-aware versions of several constructs in the Elixir Standard Library which aren&#39;t natively Multiversable. Additional plugins will be provided for other systems, such as Phoenix.PubSub Usage In your module where you&#39;ll be using at least one multiverse module, use the following header: use Multiverses, with: Registry, only: :test this aliases Multiverses.Registry to Registry and activates the Multiverses.Registry macros across this module. As an escape hatch, if you need to use the underlying module, you may use the macro alias Elixir.Registry If you need more complex choices for when to activate Multiverses (such as system environment variables), you should encode those choices directly using logic around the use Multiverses statement. Options :with the names of multiverse modules you&#39;d like to use. May be a single module or a list of modules. Is identical to require &lt;module&gt;; alias &lt;module&gt;. :only activate the multiverse system only in certain Mix environments. May be a single atom or a list of atoms.","ref":"Multiverses.html","title":"Multiverses","type":"module"},{"doc":"generates a &quot;link&quot; to current universe. If you pass the result of &quot;link&quot; to port/1, then it will bring the ported process into the universe of the process that called link/0","ref":"Multiverses.html#link/0","title":"Multiverses.link/0","type":"macro"},{"doc":"causes the current process to adopt the universe referred to by the result of a link/0 call.","ref":"Multiverses.html#port/1","title":"Multiverses.port/1","type":"macro"},{"doc":"identifies the universe of the current process.","ref":"Multiverses.html#self/0","title":"Multiverses.self/0","type":"macro"},{"doc":"","ref":"Multiverses.html#t:link/0","title":"Multiverses.link/0","type":"opaque"},{"doc":"allows a module to directly clone all of the public functions of a given module, except as macros. thus multiverse equivalents replicate the functionality of the parent module, except with the equivalents substituted at compile time, allowing multiverse apps to exist as [runtime: false] apps. Usage In the following example, FooModule has all of its functions ported into the current module, except as macros. The functions FooModule.foo/3 and FooModule.foo/4 are not, but rather should be ported using defclone/2 use Multiverses.MacroClone, with: FooModule, except: [ foo: 3, foo: 4 ]","ref":"Multiverses.MacroClone.html","title":"Multiverses.MacroClone","type":"module"},{"doc":"clones the target function from the parent module (as defined in the use statement) as a macro, unless use Multiverses has been activated. In the case that use Multiverses has been activated, the macro takes the value of the contents inside the defclone block.","ref":"Multiverses.MacroClone.html#defclone/2","title":"Multiverses.MacroClone.defclone/2","type":"macro"},{"doc":"This module is intended to be a drop-in replacement for Registry, though currently not all functionality is implemented. Unimplemented functionality: count_match/3,4 match/3,4 unregister_match/3,4","ref":"Multiverses.Registry.html","title":"Multiverses.Registry","type":"module"},{"doc":"cloned from Registry.__unregister__/3","ref":"Multiverses.Registry.html#__unregister__/3","title":"Multiverses.Registry.__unregister__/3","type":"macro"},{"doc":"retrives all processes stored in the registry by their keys. If multiverses are activated, then this shards the registry by universe, and the caller will only be able to see processes in its universe.","ref":"Multiverses.Registry.html#all/1","title":"Multiverses.Registry.all/1","type":"macro"},{"doc":"cloned from Registry.child_spec/1","ref":"Multiverses.Registry.html#child_spec/1","title":"Multiverses.Registry.child_spec/1","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#count/1","title":"Multiverses.Registry.count/1","type":"macro"},{"doc":"cloned from Registry.count_match/3","ref":"Multiverses.Registry.html#count_match/3","title":"Multiverses.Registry.count_match/3","type":"macro"},{"doc":"cloned from Registry.count_match/4","ref":"Multiverses.Registry.html#count_match/4","title":"Multiverses.Registry.count_match/4","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#dispatch/4","title":"Multiverses.Registry.dispatch/4","type":"macro"},{"doc":"retrives a process stored in the registry by its key. If multiverses are activated, then this shards the registry by universe, and the caller will only be able to see processes in its universe.","ref":"Multiverses.Registry.html#get/2","title":"Multiverses.Registry.get/2","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#keys/2","title":"Multiverses.Registry.keys/2","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#lookup/2","title":"Multiverses.Registry.lookup/2","type":"macro"},{"doc":"cloned from Registry.match/3","ref":"Multiverses.Registry.html#match/3","title":"Multiverses.Registry.match/3","type":"macro"},{"doc":"cloned from Registry.match/4","ref":"Multiverses.Registry.html#match/4","title":"Multiverses.Registry.match/4","type":"macro"},{"doc":"cloned from Registry.meta/2","ref":"Multiverses.Registry.html#meta/2","title":"Multiverses.Registry.meta/2","type":"macro"},{"doc":"cloned from Registry.put_meta/3","ref":"Multiverses.Registry.html#put_meta/3","title":"Multiverses.Registry.put_meta/3","type":"macro"},{"doc":"Registers the calling process with the Registry. Works as Registry.register/3 does.","ref":"Multiverses.Registry.html#register/3","title":"Multiverses.Registry.register/3","type":"macro"},{"doc":"cloned from Registry.register_name/2","ref":"Multiverses.Registry.html#register_name/2","title":"Multiverses.Registry.register_name/2","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#select/2","title":"Multiverses.Registry.select/2","type":"macro"},{"doc":"cloned from Registry.send/2","ref":"Multiverses.Registry.html#send/2","title":"Multiverses.Registry.send/2","type":"macro"},{"doc":"cloned from Registry.start_link/1","ref":"Multiverses.Registry.html#start_link/1","title":"Multiverses.Registry.start_link/1","type":"macro"},{"doc":"cloned from Registry.start_link/2","ref":"Multiverses.Registry.html#start_link/2","title":"Multiverses.Registry.start_link/2","type":"macro"},{"doc":"cloned from Registry.start_link/3","ref":"Multiverses.Registry.html#start_link/3","title":"Multiverses.Registry.start_link/3","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#unregister/2","title":"Multiverses.Registry.unregister/2","type":"macro"},{"doc":"cloned from Registry.unregister_match/3","ref":"Multiverses.Registry.html#unregister_match/3","title":"Multiverses.Registry.unregister_match/3","type":"macro"},{"doc":"cloned from Registry.unregister_match/4","ref":"Multiverses.Registry.html#unregister_match/4","title":"Multiverses.Registry.unregister_match/4","type":"macro"},{"doc":"cloned from Registry.unregister_name/1","ref":"Multiverses.Registry.html#unregister_name/1","title":"Multiverses.Registry.unregister_name/1","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#update_value/3","title":"Multiverses.Registry.update_value/3","type":"macro"},{"doc":"cloned from Registry.whereis_name/1","ref":"Multiverses.Registry.html#whereis_name/1","title":"Multiverses.Registry.whereis_name/1","type":"macro"}]